<template>
    <form @submit.prevent="submitSearchForm" class="flex items-end gap-3 mb-4">
        <div class="form-control">
            <div>Tên khóa học:</div>
            <label for="name">
                <input
                    v-model="name"
                    id="name"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                    placeholder="Tên khóa học..."
                    autocomplete="off"
                />
            </label>
        </div>
        <div class="form-control">
            <label for="category">
                <div>Môn học:</div>
                <select
                    v-model="category"
                    id="category"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                >
                    <option value="">Tất cả</option>
                    <option
                        :key="category.id"
                        v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                        :value="category.id"
                    >
                        {{ category.text }}
                    </option>
                </select>
            </label>
        </div>
        <BasicButton
            type="submit"
            classCustom="bg-color-warning hover:shadow-hover-warning"
        >
            <SearchIcon class="text-white" />
            <span>Tìm kiếm</span>
        </BasicButton>
    </form>
    <table>
        <thead>
            <tr>
                <th>Thông tin khóa học</th>
                <th class="text-center">Môn học</th>
                <th class="text-center">Thời gian tạo</th>
                <th class="text-center">Người duyệt</th>
                <th class="text-center">Hành động</th>
            </tr>
        </thead>
        <tbody>
            <template v-if="!isLoading">
                <template v-if="coursesComputed && coursesComputed.length">
                    <tr :key="course.id" v-for="course in coursesComputed">
                        <td class="w-400">
                            <div class="flex gap-3">
                                <img
                                    :src="
                                        course.image
                                            ? course.image
                                            : require('@/assets/images/no-image.webp')
                                    "
                                    class="w-28 min-w-28 h-full"
                                    alt=""
                                />
                                <div>
                                    <div class="text-lg font-semibold">
                                        {{ course.name }}
                                    </div>
                                    <p class="text-sm mb-1">
                                        Tổng số bài học:
                                        {{ course.total_lesson }}
                                    </p>
                                    <p class="text-sm mb-1">
                                        Tác giả:
                                        <router-link
                                            :to="{
                                                name: 'admin-user-view',
                                                params: {
                                                    userId: course.created_by.id
                                                }
                                            }"
                                            class="inline-block bg-color-primary text-white text-xs rounded-2xl px-2 py-1"
                                        >
                                            {{ course.created_by.name }}
                                        </router-link>
                                    </p>
                                </div>
                            </div>
                        </td>
                        <td class="text-center">
                            {{ course.course_category }}
                        </td>
                        <td class="text-center">{{ course.created_at }}</td>
                        <td class="text-center">
                            <router-link
                                :to="{
                                    name: 'admin-user-view',
                                    params: { userId: course.approver?.id }
                                }"
                                class="text-main-color"
                            >
                                {{ course.approver?.name }}
                            </router-link>
                        </td>
                        <td>
                            <div
                                class="box-actions flex items-center justify-center gap-1"
                            >
                                <router-link
                                    :to="{
                                        name: 'admin-course-view',
                                        params: { courseId: course.id },
                                        hash: '#overview'
                                    }"
                                    v-tooltip="'Xem'"
                                    class="action-view"
                                >
                                    <EyeIcon />
                                </router-link>
                            </div>
                        </td>
                    </tr>
                </template>
                <template v-else>
                    <tr class="no-data-table">
                        <td colspan="6" class="text-center">
                            Không có dữ liệu
                        </td>
                    </tr>
                </template>
            </template>
            <template v-else>
                <tr>
                    <td colspan="6" class="text-center">
                        <SpinLoading />
                    </td>
                </tr>
            </template>
        </tbody>
    </table>
    <div
        v-if="!isLoading && coursesComputed && coursesComputed.length"
        class="flex justify-end p-6"
    >
        <BasicPagination
            @onClickPage="onClickPage"
            :currentPage="currentPage"
            :lastPage="lastPage"
        />
    </div>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import { SELECT_OPTION_COURSE_CATEGORY } from "@/constants";
import timeHelper from "@/helper/timeHelper";

import useFetchAllCoursePublic from "@/hooks/course/useFetchAllCoursePublic";

import { SearchIcon, EyeIcon } from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";

export default {
    components: {
        SearchIcon,
        EyeIcon,
        SpinLoading,
        BasicButton,
        BasicPagination
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const courses = ref([]);
        const {
            isLoading,
            listCourse,
            onFetchAllCoursePublic
        } = useFetchAllCoursePublic();

        async function onFetch() {
            await onFetchAllCoursePublic(route.query);
            courses.value = listCourse.value.data;
        }
        onFetch();

        const coursesComputed = computed(() => {
            if (courses.value && courses.value.length) {
                return courses.value.map(course => {
                    let course_category;
                    SELECT_OPTION_COURSE_CATEGORY.forEach(category => {
                        if (course.course_category_id === category.id)
                            course_category = category.text;
                    });
                    return {
                        ...course,
                        course_category,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(course.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        const name = ref(route.query.name || null);
        const category = ref(route.query.category || "");
        async function submitSearchForm() {
            await onFetchAllCoursePublic({
                name: name.value,
                category: category.value
            });
            courses.value = listCourse.value.data;

            const path = route.path;
            const hash = route.hash;

            let query = {};
            if (name.value) query = { ...query, name: name.value };
            if (category.value !== null && category.value !== "")
                query = { ...query, category: category.value };

            router.push({ path, query, hash });
        }

        // update currentPge and lastPage when change listCourse
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listCourse, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value },
                hash: route.hash
            });

            await onFetchAllCoursePublic({ ...route.query, page: value });
            courses.value = listCourse.value.data;
        }

        return {
            SELECT_OPTION_COURSE_CATEGORY,
            isLoading,
            coursesComputed,
            name,
            category,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage
        };
    }
};
</script>
